SystemOrganization addCategory: #'Pier-Math'!

!PRViewRenderer methodsFor: '*pier-math-visiting' stamp: 'lr 11/13/2007 10:50'!
visitMathText: anObject
	html image form: anObject image; altText: anObject text ! !

!PRVisitor methodsFor: '*pier-math-visiting' stamp: 'lr 5/1/2007 20:38'!
visitMathText: anObject
	self visitText: anObject! !

PRText subclass: #PMMathText
	instanceVariableNames: 'image'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Math'!

!PMMathText class methodsFor: 'initialization' stamp: 'lr 11/13/2007 10:22'!
initialize
	PRDocumentParser textMatcher at: self markup put: self! !

!PMMathText class methodsFor: 'accessing' stamp: 'lr 11/13/2007 10:21'!
markup
	^ '$$'! !

!PMMathText class methodsFor: 'instance-creation' stamp: 'lr 5/1/2007 20:42'!
parse: aString with: aParser
	^ self content: (aString copyFrom: self markup size + 1 to: aString size - self markup size)! !

!PMMathText class methodsFor: 'initialization' stamp: 'lr 5/1/2007 20:36'!
unload
	PRDocumentParser textMatcher removeKey: self markup ifAbsent: [ ]! !

!PMMathText methodsFor: 'visiting' stamp: 'lr 5/1/2007 20:37'!
accept: aVisitor
	aVisitor visitMathText: self! !

!PMMathText methodsFor: 'private' stamp: 'lr 11/13/2007 10:59'!
buildImage
	| fullname stream |
	[ fullname := self directory fullNameFor: self filename.
	[ stream := FileStream forceNewFileNamed: fullname , '.tex'.
	[ stream nextPutAll: self preamble; nextPutAll: self text; nextPutAll: self postscript ]
		ensure: [ stream close ].
	OSProcess waitForCommand: self latex , ' -output-directory=' , self directory fullName printString , ' -output-format=dvi ' , (fullname , '.tex') printString , ' >/dev/null'.
	OSProcess waitForCommand: self dvipng , ' -gamma 1.5 -D 120 -T tight --strict ' , (fullname , '.dvi') printString , ' -o ' , (fullname , '.png') printString , ' >/dev/null 2>/dev/null'.
	stream := FileStream oldFileNamed: fullname , '.png'.
	[ ^ MIMEDocument contentType: 'image/png' content: (stream binary; contents) ] 
		ensure: [ stream close ] ] 
		ensure: [
			self directory
				deleteFileNamed: self filename , '.tex';
				deleteFileNamed: self filename , '.dvi';
				deleteFileNamed: self filename , '.aux';
				deleteFileNamed: self filename , '.log';
				deleteFileNamed: self filename , '.png' ] ]
		ifError: [ :err | ^ err description asDisplayText form asMIMEDocument ]! !

!PMMathText methodsFor: 'configuration' stamp: 'lr 5/1/2007 22:11'!
directory
	^ FileDirectory default! !

!PMMathText methodsFor: 'configuration' stamp: 'lr 11/13/2007 10:47'!
dvipng
	^ '/usr/texbin/dvipng'! !

!PMMathText methodsFor: 'configuration' stamp: 'lr 5/1/2007 21:27'!
filename
	^ 'pier-math-' , self hash asString! !

!PMMathText methodsFor: 'accessing' stamp: 'lr 11/13/2007 10:52'!
image
	"Answer a cached mime document of the receivers image."
	
	^ image ifNil: [ image := self buildImage ]! !

!PMMathText methodsFor: 'configuration' stamp: 'lr 11/13/2007 10:46'!
latex
	^ '/usr/texbin/latex'! !

!PMMathText methodsFor: 'configuration' stamp: 'lr 11/13/2007 11:09'!
postscript
	^ '\]
\end{document}'! !

!PMMathText methodsFor: 'configuration' stamp: 'lr 11/13/2007 11:09'!
preamble
	^ '\nonstopmode
\documentclass[12pt]{article}

\usepackage{amsmath}
\usepackage{amsfonts}
\usepackage{amssymb}
\usepackage{ucs}
\usepackage[utf8x]{inputenc}
\usepackage[dvips,usenames]{color}
\pagestyle{empty}
\begin{document}
\['! !

!PMMathText methodsFor: 'accessing' stamp: 'lr 11/13/2007 10:51'!
text: aString
	super text: aString.
	image := nil! !

!PRWikiWriter methodsFor: '*pier-math-visiting' stamp: 'lr 11/13/2007 10:27'!
visitMathText: anObject
	self 
		nextPutAll: anObject class markup; 
		nextPutAll: anObject text;
		nextPutAll: anObject class markup! !
PMMathText initialize!
